--[[
BY
 _____   _____   __   _  
|  _  \ /  _  \ |  \ | | 
| | | | | | | | |   \| | 
| | | | | | | | | |\   | 
| |_| | | |_| | | | \  | 
|_____/ \_____/ |_|  \_| 

]]

local playerscreenmenudon = require("screens/securitycontainerdonscreen")
local cod_json = require("json")

local Securitycontainerdon = Class(function(self, inst)
    self.inst = inst
    self.writer = nil 
	self.ownerchestname = nil	
	self.securitykeydon = nil --netvar
	self.lastopenname = nil --netvar
	self.ownerchestiduniq = nil --netvar
	
	self.currentidskinchest = 1
	self.maxcurrentidskinchest = nil

    self.onclosepopups = function(doer)
        if doer == self.writer then
            self:EndWritingPassword()
        end
    end
    
    inst:AddTag("_securitycontainerdon")
	
	inst:AddTag("accept_donlocksystem")	
end)

function Securitycontainerdon:OnSave()
    local data = {}

    data.securitykeydon = self.securitykeydon
    data.ownerchestname = self.ownerchestname
    data.ownerchestiduniq = self.ownerchestiduniq
	
    data.lastopenname = self.lastopenname
	
    data.currentidskinchest = self.currentidskinchest
   
    return data
end

function Securitycontainerdon:OnLoad(data)
    self.securitykeydon = data.securitykeydon
    self.ownerchestname = data.ownerchestname
    self.ownerchestiduniq = data.ownerchestiduniq
	
    self.lastopenname = data.lastopenname
	
	self.currentidskinchest = data.currentidskinchest

	if self.inst.components.container ~= nil then
        self.inst.components.container.canbeopened = false
        self.inst.components.container:Close()
	end

	if self.currentidskinchest == nil then
		self.currentidskinchest = 1
	end
	
	if self.lastopenname == nil then
		self.lastopenname = "?"
	end
	
	
	--SetNetVar:
	if self.securitykeydon ~= nil then
    self.inst.replica.securitycontainerdon.getsecuritykeydon:set_local(self.securitykeydon)
    self.inst.replica.securitycontainerdon.getsecuritykeydon:set(self.securitykeydon)
	end
	if self.lastopenname ~= nil then
	self.inst.replica.securitycontainerdon.getlastopenname:set_local(self.lastopenname)
    self.inst.replica.securitycontainerdon.getlastopenname:set(self.lastopenname)
	end
	if self.ownerchestiduniq ~= nil then
	self.inst.replica.securitycontainerdon.getownerchestiduniq:set_local(self.ownerchestiduniq)
    self.inst.replica.securitycontainerdon.getownerchestiduniq:set(self.ownerchestiduniq)
	end
	--
end

function Securitycontainerdon:GetLastOpenName()
	return self.lastopenname
end

function Securitycontainerdon:GetOwnerSecurity()
	return self.ownerchestname
end

function Securitycontainerdon:ChangeSkinChest()
	local calidskinchest = (self.currentidskinchest + 1)
    self.currentidskinchest = calidskinchest
	
	if self.currentidskinchest > self.maxcurrentidskinchest then
		self.currentidskinchest = 1
	end	
	
	if self.onupdateskinschestfn ~= nil then
        self.onupdateskinschestfn(self.inst)
    end
	
end

function Securitycontainerdon:SetNewPassword(doer)
	if self.inst.components.container ~= nil then
        self.inst.components.container.canbeopened = false
        self.inst.components.container:Close()
	end
	playerscreenmenudon(self.inst, doer, "register")
end


function Securitycontainerdon:DestroyOnCancel()
	if self.ondestroyoncancelfn ~= nil then
        self.ondestroyoncancelfn(self.inst)
    end
	self.inst.components.container:Close()
end

function Securitycontainerdon:OnDropEverything()
	if self.inst.components.container ~= nil then
        self.inst.components.container:DropEverything()		
    end
end

function Securitycontainerdon:IsBeingWrittenPassword(doer)	
	return self.writer ~= nil
end	

function Securitycontainerdon:BeginWritingPassword(doer)

	if self.inst.components.container:IsOpen() then
		self.inst.components.container:Close()
		self.writer = nil
	else
			
    if self.writer ~= nil then
        return
    end

    self.inst:StartUpdatingComponent(self)
    self.writer = doer

    self.inst:ListenForEvent("ms_closepopups", self.onclosepopups, doer)
    self.inst:ListenForEvent("onremove", self.onclosepopups, doer)

    if doer ~= nil and doer == ThePlayer then		
       if doer.HUD ~= nil then
			if self.securitykeydon == nil or self.securitykeydon == "" then
				playerscreenmenudon(self.inst, doer, "register")
			else
				playerscreenmenudon(self.inst, doer, "login")
			end
        else	
			return false
        end
    else
        return false
    end
	
    end
end

function Securitycontainerdon:EndWritingPassword()
    if self.writer == nil then
        return
    end
    self.inst:StopUpdatingComponent(self)
    
    self.inst:RemoveEventCallback("ms_closepopups", self.onclosepopups, self.writer)
    self.inst:RemoveEventCallback("onremove", self.onclosepopups, self.writer)
    
    self.writer = nil
end

function Securitycontainerdon:SetSecurityKeyPassword(password, ownername, ownerid, doer)
   
   self.securitykeydon = cod_json.encode(tostring(password))
	
	if self.ownerchestname == nil then
		self.ownerchestname = tostring(ownername)
	end
	
	if self.ownerchestiduniq == nil then
		self.ownerchestiduniq = cod_json.encode(tostring(ownerid))
	end
	
	if doer ~= nil and doer == ThePlayer and doer.HUD ~= nil then
		playerscreenmenudon(self.inst, doer, "login")
	end
end

function Securitycontainerdon:SetLastOpener(openername)
	self.lastopenname = tostring(openername)
end

function Securitycontainerdon:ReloadOwnerName(ownername)
   
	if self.ownerchestname ~= nil then
		self.ownerchestname = tostring(ownername)
	end

end

function Securitycontainerdon:TryUnlockContainer(doer, password)
	if self.securitykeydon == cod_json.encode(tostring(password)) then
		--senha ok!--
		
		self:SetLastOpener(doer.name)
		
		if cod_json.encode(tostring(doer.userid)) == self.ownerchestiduniq then
			self:ReloadOwnerName(doer.name)		
		end
		
		playerscreenmenudon(self.inst, doer, "openedmenu")
	else
		--senha errada!--
		self.inst.AnimState:PlayAnimation("hit")
		self.inst.AnimState:PushAnimation("closed", true)
		self.inst.SoundEmitter:PlaySound("dontstarve/wilson/hit_wood")
	end	
end


function Securitycontainerdon:OpenChestSecurity(doer)
    if self.inst.components.container ~= nil then
        self.inst.components.container.canbeopened = true
		self.inst.components.container:Open(doer)
		self.inst.components.container.canbeopened = false
	end
end


function Securitycontainerdon:OnUpdate(dt)
    if self.writer == nil then
        self.inst:StopUpdatingComponent(self)
    elseif (self.writer.components.rider ~= nil
            and self.writer.components.rider:IsRiding())
        or not (self.writer:IsNear(self.inst, 3)
            and CanEntitySeeTarget(self.writer, self.inst))
    then
        self:EndWritingPassword()
    end
end


function Securitycontainerdon:OnRemoveFromEntity()
    self:EndWritingPassword()
	self.inst:RemoveEventCallback("onbuilt", onbuilt)
    self.inst:RemoveTag("_securitycontainerdon")
end

function Securitycontainerdon:OnRemoveEntity()
    self:EndWritingPassword()
end

function Securitycontainerdon:Destroy()
end

return Securitycontainerdon