--[[
BY
 _____   _____   __   _  
|  _  \ /  _  \ |  \ | | 
| | | | | | | | |   \| | 
| | | | | | | | | |\   | 
| |_| | | |_| | | | \  | 
|_____/ \_____/ |_|  \_| 

]]

local playerscreenmenudon = require("screens/securitycontainerdonscreen")
local cod_json = require("json")


local function DonSendModRPCToServer(...) 
    SendModRPCToServer({namespace = "CONTAINERDONOPENCONTAINER", id = MOD_RPC["CONTAINERDONOPENCONTAINER"]["SetRpcContainerInfos"].id}, ...)
end

local Securitycontainerdon = Class(function(self, inst)
    self.inst = inst
    self.getsecuritykeydon = net_string(inst.GUID, "securitycontainerdon.getsecuritykeydon", "setsecuritykeynetvar")
    self.getlastopenname = net_string(inst.GUID, "securitycontainerdon.getlastopenname", "setlastopenernamenetvar")
    self.getownerchestiduniq = net_string(inst.GUID, "securitycontainerdon.getownerchestiduniq", "setownerchestiduniqnetvar")
	self.writer = nil

    if not TheWorld.ismastersim then
        self.securitykeydon = nil
		self.lastopenname = nil
		self.ownerchestiduniq = nil
        
        self.OnSetsecuritykeynetvar = function()
            if self.getsecuritykeydon:value() == nil or self.getsecuritykeydon:value() == "" then	return false end		
            self.securitykeydon = self.getsecuritykeydon:value()
            self.getsecuritykeydon:set_local("")
            return true
        end
		
		self.OnSetlastopenernamenetvar = function()
            if self.getlastopenname:value() == nil or self.getlastopenname:value() == "" then return false end
			self.lastopenname = self.getlastopenname:value()
            self.getlastopenname:set_local("")
            return true
        end
		
		self.OnSetownerchestiduniqnetvar = function()
            if self.getownerchestiduniq:value() == nil or self.getownerchestiduniq:value() == "" then return false end
			self.lastopenname = self.getownerchestiduniq:value()
            self.getownerchestiduniq:set_local("")
            return true
        end
		
        self.OnRemoveFromEntity = function(self)
            self:RemoveEventCallback("setsecuritykeynetvar", self.OnSetsecuritykeynetvar)
            self:RemoveEventCallback("setlastopenernamenetvar", self.OnSetlastopenernamenetvar)
            self:RemoveEventCallback("setownerchestiduniqnetvar", self.OnSetownerchestiduniqnetvar)
        end
        
        inst:ListenForEvent("setsecuritykeynetvar", self.OnSetsecuritykeynetvar)
        inst:ListenForEvent("setlastopenernamenetvar", self.OnSetlastopenernamenetvar)
        inst:ListenForEvent("setownerchestiduniqnetvar", self.OnSetownerchestiduniqnetvar)
    end
end)


function Securitycontainerdon:IsBeingWrittenPassword(doer)	
    if self.inst.components.securitycontainerdon ~= nil then
		self.inst.components.securitycontainerdon:IsBeingWrittenPassword(doer)	
	else
		return self.writer ~= nil
	end
end	


function Securitycontainerdon:GetPlayerOwnerKeyId()	
    if self.inst.components.securitycontainerdon ~= nil then
		return self.inst.components.securitycontainerdon.ownerchestiduniq
	else
		return self.ownerchestiduniq
	end
end	

function Securitycontainerdon:BeginWritingPassword(doer)
	
    if self.inst.components.securitycontainerdon ~= nil then
		self.inst.components.securitycontainerdon:BeginWritingPassword(doer)	
	elseif doer == nil then
        return false
    elseif doer ~= ThePlayer then
        return false
    elseif doer.HUD == nil then
        return false
    else
	
		if self.writer ~= nil then
			return
		end
	
		self.writer = doer
		
		if self.inst.replica.container._isopen == true then
			self.writer = nil
			DonSendModRPCToServer(self.inst, "CloseChest")	
		else
			if self.securitykeydon == nil or self.securitykeydon == "" then
				playerscreenmenudon(self.inst, doer, "register")	
			else	
				playerscreenmenudon(self.inst, doer, "login")
			end		
		end		
    end

end


function Securitycontainerdon:EndWritingPassword()
    if self.inst.components.securitycontainerdon ~= nil then
        return self.inst.components.securitycontainerdon:EndWritingPassword()
    else
		self.writer = nil
	end	
end

function Securitycontainerdon:GetLastOpenName()
    if self.inst.components.securitycontainerdon ~= nil then
        return self.inst.components.securitycontainerdon:GetLastOpenName()
    else
		return self.lastopenname
	end
end

function Securitycontainerdon:DestroyOnCancel()
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:DestroyOnCancel()
    else
		DonSendModRPCToServer(self.inst, "DestroyonCancel")		
    end
end

function Securitycontainerdon:OnDropEverything()
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:OnDropEverything()
    else
		DonSendModRPCToServer(self.inst, "OnDropEverything")		
    end
end

function Securitycontainerdon:ChangeSkinChest()
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:ChangeSkinChest()
    else
		DonSendModRPCToServer(self.inst, "ChangeSkinChest")		
    end
end

function Securitycontainerdon:SetNewPassword(doer)
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:SetNewPassword(doer)
    else
		playerscreenmenudon(self.inst, doer, "register")
		DonSendModRPCToServer(self.inst, "CloseChest")	
    end
end

function Securitycontainerdon:SetSecurityKeyPassword(password, doer)
	local ownername = tostring(doer.name)
	local ownerid = tostring(doer.userid)
	
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:SetSecurityKeyPassword(password, ownername, ownerid, doer)
    elseif (password == nil or password:utf8len() <= TUNING.DONSECURITYPASS_MAXLENGTHLIMIT) then
		self.securitykeydon = cod_json.encode(password) --local
		DonSendModRPCToServer(self.inst, "RegisterPw", password, ownername, ownerid)	
		playerscreenmenudon(self.inst, doer, "login")		
    end
end

function Securitycontainerdon:OpenChestSecurity(doer)
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:OpenChestSecurity(doer)
    else
		DonSendModRPCToServer(self.inst, "OpenChest")		
    end
end


local function CheckLoginLocal(self, doer, password)
	if self.securitykeydon == cod_json.encode(tostring(password)) then
		--senha ok!--

		self.lastopenname = doer.name --local
		DonSendModRPCToServer(self.inst, "LastOpener", doer.name)	
		
		if cod_json.encode(tostring(doer.userid)) == self:GetPlayerOwnerKeyId() then
			DonSendModRPCToServer(self.inst, "ReloadOwnerName", doer.name)		
		end
		
		playerscreenmenudon(self.inst, doer, "openedmenu")
	else
		--senha errada!--
		self.inst.AnimState:PlayAnimation("hit")
		self.inst.AnimState:PushAnimation("closed", true)
		self.inst.SoundEmitter:PlaySound("dontstarve/wilson/hit_wood")
	end	
end

function Securitycontainerdon:TryUnlockContainer(doer, password)
	if self.inst.components.securitycontainerdon ~= nil then
        self.inst.components.securitycontainerdon:TryUnlockContainer(doer, password)
    elseif (password == nil or password:utf8len() <= TUNING.DONSECURITYPASS_MAXLENGTHLIMIT) then
		CheckLoginLocal(self, doer, password)
    end
end

return Securitycontainerdon