--[[
BY
 _____   _____   __   _  
|  _  \ /  _  \ |  \ | | 
| | | | | | | | |   \| | 
| | | | | | | | | |\   | 
| |_| | | |_| | | | \  | 
|_____/ \_____/ |_|  \_| 

]]

local Widget = require "widgets/widget"
local Text = require "widgets/text"
local TextEdit = require "widgets/textedit"
local Screen = require "widgets/screen"
local Menu = require "widgets/menu"
local cod_json = require("json")
local ImageButton = require "widgets/imagebutton"
local UIAnim = require "widgets/uianim"

--Basiado em: Writable_replica/widget


local config_all_ui =
{
    --pos = Vector3(0, 0, 0),
    menuoffset = Vector3(6, -70, 0),
	--bgatlas = "",
	--bgimage = "",
    animbank = "ui_board_5x3",
    animbuild = "ui_board_5x3",
}

local function CheckIsOwnerPermi(widget)
	if widget.owner.userid ~= nil and widget.writeable.replica.securitycontainerdon:GetPlayerOwnerKeyId() ~= nil and
	cod_json.encode(tostring(widget.owner.userid)) == (widget.writeable.replica.securitycontainerdon:GetPlayerOwnerKeyId()) then
		return true
	else
		return false
	end
end

local localtimer = nil

local function MSGerror(widget, msgerrotext)

	if localtimer ~= nil then
        localtimer:Cancel()
        localtimer = nil
    end
	
	widget.msgerror:SetString((STRINGS.DONTEXT_ERRO_TITLE..": "..msgerrotext.."!"))
	
	localtimer = widget.inst:DoTaskInTime(3.5, function() 
		widget.msgerror:SetString("")
	end)

end

local function onlockunlock(widget)
    if not widget.isopen then
        return
    end
	
	local msg = widget:GetText()
	local writer = widget.owner
    local processed_msg = msg:match("^%s*(.-%S)%s*$") or ""
    if msg ~= processed_msg or #msg <= 0 then
        widget.edit_text:SetString(processed_msg)
        widget.edit_text:SetEditing(true)
        return
    end

    if widget.writeable.replica ~= nil then	
		if widget.checkmethod ~= nil then
			if widget.checkmethod == "register" then
				widget.writeable.replica.securitycontainerdon:SetSecurityKeyPassword(msg, writer)
			end
			if widget.checkmethod == "login" then
				widget.writeable.replica.securitycontainerdon:TryUnlockContainer(writer, msg)
			end
		end	
    end

    widget:Close()
end

local function onresettext(widget)
    if not widget.isopen then
        return
    end
    
    widget:OverrideText("")
	widget.edit_text:SetEditing(true)
end

local function oncancel(widget)
    if not widget.isopen then
        return
    end
	
    widget:Close()
end


--B

local function onopenchest(widget)
    if not widget.isopen then
        return
    end

	if widget.checkmethod == "openedmenu" then
		widget.writeable.replica.securitycontainerdon:OpenChestSecurity(widget.owner)
	end

    widget:Close()
end


--C

local function ondropallitens(widget)
    if not widget.isopen then
        return
    end

	if widget.checkmethod == "openedmenu" then
		if widget.writeable.replica ~= nil then		
			widget.writeable.replica.securitycontainerdon:OnDropEverything()
		end
    end
	
end


local function ondestroychest(widget)
    if not widget.isopen then
        return
    end

	if CheckIsOwnerPermi(widget) == true then
		if widget.checkmethod == "openedmenu" then
			if widget.writeable.replica ~= nil then		
				widget.writeable.replica.securitycontainerdon:DestroyOnCancel()
			end		
		end
		widget:Close()
	else
		MSGerror(widget, STRINGS.DONTEXT_ERRO_NOPERMISSION)
    end

    
end

--C

local function onchangeskinchest(widget)
    if not widget.isopen then
        return
    end

	if CheckIsOwnerPermi(widget) == true then	
		if widget.checkmethod == "openedmenu" then
			if widget.writeable.replica ~= nil then		
				widget.writeable.replica.securitycontainerdon:ChangeSkinChest()
			end
		end
	else
		MSGerror(widget, STRINGS.DONTEXT_ERRO_NOPERMISSION)
    end

end

local function onnewpasswordbtn(widget)
    if not widget.isopen then
        return
    end

	if CheckIsOwnerPermi(widget) == true then	
		if widget.checkmethod == "openedmenu" then
			if widget.writeable.replica ~= nil then		
				widget.writeable.replica.securitycontainerdon:SetNewPassword(widget.owner)
			end
		end
		widget:Close()
	else
		MSGerror(widget, STRINGS.DONTEXT_ERRO_NOPERMISSION)
    end

end

local function EndWritingPassword(obj)
    obj.replica.securitycontainerdon:EndWritingPassword()
end


local SecuritycontainerdonScreen = Class(Screen, function(self, owner, writeable, methodmenu)
    Screen._ctor(self, "SecuritycontainerdonScreen")

	self.owner = owner
    self.writeable = writeable
	self.checkmethod = methodmenu
	self.config_current = config_all_ui
	self.lockorunlocktextbtn = ""
	self.prompttitletext = ""
	self.strpermiuser = ""

	
	if self.checkmethod == "register" then
		self.lockorunlocktextbtn = STRINGS.DONTEXT_LOCK
	else
		self.lockorunlocktextbtn = STRINGS.DONTEXT_UNLOCK
	end
	
	if CheckIsOwnerPermi(self) then
		self.strpermiuser = STRINGS.DONTEXT_OWNER
	else
		self.strpermiuser = STRINGS.DONTEXT_USER
	end
	
	if self.checkmethod == "register" then
		self.prompttitletext = (STRINGS.DONTEXT_TITLELOCK..":")
	elseif self.checkmethod == "login" then
		self.prompttitletext = (STRINGS.DONTEXT_TITLEUNLOCK..":")
	elseif self.checkmethod == "openedmenu" then
		self.prompttitletext = (STRINGS.DONTEXT_TITLEMENUOPEN.." ("..STRINGS.DONTEXT_PERMISSION..": "..self.strpermiuser..")")
	end
	
    self.isopen = false

	self._scrnw, self._scrnh = TheSim:GetScreenSize()

    self:SetScaleMode(SCALEMODE_PROPORTIONAL)
    self:SetMaxPropUpscale(MAX_HUD_SCALE)
    self:SetPosition(0, 0, 0)
    self:SetVAnchor(ANCHOR_MIDDLE)
    self:SetHAnchor(ANCHOR_MIDDLE)

    self.scalingroot = self:AddChild(Widget("writeablewidgetscalingroot"))
    self.scalingroot:SetScale(TheFrontEnd:GetHUDScale())
    self.inst:ListenForEvent("continuefrompause", function()
        if self.isopen then
            self.scalingroot:SetScale(TheFrontEnd:GetHUDScale())
        end
    end, TheWorld)
    self.inst:ListenForEvent("refreshhudsize", function(hud, scale)
        if self.isopen then
            self.scalingroot:SetScale(scale)
        end
    end, owner.HUD.inst)

    self.root = self.scalingroot:AddChild(Widget("writeablewidgetroot"))
    self.root:SetScale(.6, .6, .6)

    self.black = self.root:AddChild(Image("images/global.xml", "square.tex"))
    self.black:SetVRegPoint(ANCHOR_MIDDLE)
    self.black:SetHRegPoint(ANCHOR_MIDDLE)
    self.black:SetVAnchor(ANCHOR_MIDDLE)
    self.black:SetHAnchor(ANCHOR_MIDDLE)
    self.black:SetScaleMode(SCALEMODE_FILLSCREEN)
    self.black:SetTint(0, 0, 0, 0)
    self.black.OnMouseButton = function() oncancel(self.writeable, self.owner, self) end

    self.bganim = self.root:AddChild(UIAnim())
    self.bganim:SetScale(1, 1, 1)
    self.bgimage = self.root:AddChild(Image())
    self.bganim:SetScale(1, 1, 1)

    self.title = self.root:AddChild(Text(UIFONT, 40))
    self.title:SetPosition(0, 115, 0)
	self.title:SetString(self.prompttitletext)
	
	if self.checkmethod == "register" then
		self.title:SetColour(39/255, 194/255, 209/255, .95)
	else
		self.title:SetColour(39/255, 209/255, 111/255, .95)
	end
	
	self.titleB = self.root:AddChild(Text(UIFONT, 40))
    self.titleB:SetPosition(0, 67, 0)
	self.titleB:SetColour(39/255, 194/255, 209/255, .95)
	
	if self.writeable.replica.securitycontainerdon:GetLastOpenName() ~= nil then
		self.titleB:SetString(STRINGS.DONTEXT_TITLELASTACESS..": "..self.writeable.replica.securitycontainerdon:GetLastOpenName())
	end

	
	self.msgerror = self.root:AddChild(Text(UIFONT, 35))
    self.msgerror:SetPosition(0, -100, 0)
	self.msgerror:SetColour(201/255, 27/255, 27/255, .95)
	self.msgerror:SetString("")

	
    self.edit_text_bg = self.root:AddChild(Image("images/textboxes.xml", "textbox_long.tex"))
    self.edit_text_bg:SetPosition(0, 12.5, 0)
    self.edit_text_bg:ScaleToSize(475, 150)

    self.edit_text = self.root:AddChild(TextEdit(TITLEFONT, 95, ""))
    self.edit_text:SetColour(0, 0, 0, .95)
    self.edit_text:SetForceEdit(true)
    self.edit_text:SetPosition(0, 5, 0)
    self.edit_text:SetRegionSize(430, 160)
    self.edit_text:SetHAlign(ANCHOR_MIDDLE)
    self.edit_text:SetVAlign(ANCHOR_MIDDLE)
    self.edit_text:SetFocusedImage(self.edit_text_bg, "images/textboxes.xml", "textbox_long_over.tex", "textbox_long.tex")
    self.edit_text:SetTextLengthLimit(TUNING.DONSECURITYPASS_MAXLENGTHLIMIT)
    self.edit_text:EnableWordWrap(true)
    self.edit_text:EnableWhitespaceWrap(true)
    self.edit_text:EnableRegionSizeLimit(true)
    self.edit_text:EnableScrollEditWindow(false)
	
    -------------------------------------------------------------------------------

	if self.checkmethod ~= "openedmenu" then
	
	self.buttons = {
		{
			text = STRINGS.DONTEXT_BTN_CANCEL,
			cb = function()
				oncancel(self)
			end,
			control = CONTROL_CANCEL
		},
		{
			text = STRINGS.DONTEXT_BTN_RESET,
			cb = function()
				onresettext(self)
			end,
			control = CONTROL_MENU_MISC_1
		},
		{	
			text = self.lockorunlocktextbtn,
			cb = function()
				onlockunlock(self)
			end,
			control = CONTROL_ACCEPT
		},
	}

	for i, v in ipairs(self.buttons) do
		if v.control ~= nil then
			self.edit_text:SetPassControlToScreen(v.control, true)
		end
	end
	
	else

	--B
    self.buttonsB = {
		{
			text = STRINGS.DONTEXT_BTN_OPENCHEST,
			cb = function()
				onopenchest(self)
			end,
			control = CONTROL_ACCEPT
		},
		{
			text = STRINGS.DONTEXT_BTN_DROPALL,
			cb = function()
				ondropallitens(self)
			end,
			control = CONTROL_MENU_MISC_1
		},
		{
			text = STRINGS.DONTEXT_BTN_DESTROY,
			cb = function()
				ondestroychest(self)
			end,
			control = CONTROL_ZOOM_IN
		},		
	}
	
	--C
	self.buttonsC = {		
		{
			text = STRINGS.DONTEXT_BTN_CHANGESKIN,
			cb = function()
				onchangeskinchest(self)
			end,
			control = CONTROL_ZOOM_OUT
		},
		{
			text = STRINGS.DONTEXT_BTN_NEWPASSWORD,
			cb = function()
				onnewpasswordbtn(self)
			end,
			control = CONTROL_MENU_MISC_2
		},
		{
			text = STRINGS.DONTEXT_BTN_CLOSEMENU,
			cb = function()
				oncancel(self)
			end,
			control = CONTROL_CANCEL
		},

	}

	for i, v in ipairs(self.buttonsB) do
		if v.control ~= nil then
			self.edit_text:SetPassControlToScreen(v.control, true)
		end
	end
	for i, v in ipairs(self.buttonsC) do
		if v.control ~= nil then
			self.edit_text:SetPassControlToScreen(v.control, true)
		end
	end
	
	
	end
    

	if self.checkmethod ~= "openedmenu" then
		local menuoffset = self.config_current.menuoffset or Vector3(0, 0, 0)
		local posyoffset = menuoffset.y-22
	
		local spacing = 110
		self.menu = self.root:AddChild(Menu(self.buttons, spacing, true, "small"))
		self.menu:SetTextSize(35)
		self.menu:SetPosition(menuoffset.x - .5 * spacing * (#self.buttons - 1), posyoffset, menuoffset.z)

		for i, v in ipairs(self.menu.items) do
			v:SetControl(CONTROL_ACCEPT)
		end 
	

	else
	
		local menuoffsetB = self.config_current.menuoffset or Vector3(0, 0, 0)
		local posyoffsetB = menuoffsetB.y+80
		
		local spacing = 110
		self.menuB = self.root:AddChild(Menu(self.buttonsB, spacing, true, "small"))
		self.menuB:SetTextSize(31)		
		self.menuB:SetPosition(menuoffsetB.x - .5 * spacing * (#self.buttonsB - 1), posyoffsetB, menuoffsetB.z)

		for i, v in ipairs(self.menuB.items) do
			v:SetControl(CONTROL_ACCEPT)
		end
		
	
		local menuoffsetC = self.config_current.menuoffset or Vector3(0, 0, 0)
		local posyoffsetC = menuoffsetC.y+17

		local spacing = 110
		self.menuB = self.root:AddChild(Menu(self.buttonsC, spacing, true, "small"))
		self.menuB:SetTextSize(31)		
		self.menuB:SetPosition(menuoffsetC.x - .5 * spacing * (#self.buttonsC - 1), posyoffsetC, menuoffsetC.z)

		for i, v in ipairs(self.menuB.items) do
			v:SetControl(CONTROL_ACCEPT)
		end
	
    end
    
    self:OverrideText("")
    self.edit_text:OnControl(CONTROL_ACCEPT, false)
    self.edit_text.OnTextEntered = function() self:OnControl(CONTROL_ACCEPT, false) end
    self.edit_text:SetHelpTextApply("")
    self.edit_text:SetHelpTextCancel("")
    self.edit_text:SetHelpTextEdit("")
    self.default_focus = self.edit_text
	
	if self.config_current.bgatlas ~= nil and self.config_current.bgimage ~= nil then
        self.bgimage:SetTexture(self.config_current.bgatlas, self.config_current.bgimage)
    end

    if self.config_current.animbank ~= nil then
        self.bganim:GetAnimState():SetBank(self.config_current.animbank)
    end

    if self.config_current.animbuild ~= nil then
        self.bganim:GetAnimState():SetBuild(self.config_current.animbuild)
    end

    if self.config_current.pos ~= nil then
        self.root:SetPosition(self.config_current.pos)
    else
        self.root:SetPosition(0, 150, 0)
    end
	
    self:Show()	
	
	if self.checkmethod == "openedmenu" then
		self.edit_text:Kill()
		self.edit_text_bg:Kill()
		if self.menu then
            self.menu:Clear()
        end	
	else
		self.titleB:Kill()
		if self.menuB then
            self.menuB:Clear()
        end	
		if self.menuC then
            self.menuC:Clear()
        end	
	end
	
end)

function SecuritycontainerdonScreen:OnBecomeActive()
    self._base.OnBecomeActive(self)
    self.edit_text:SetFocus()
    self.edit_text:SetEditing(true)
end

function SecuritycontainerdonScreen:Show()
    SecuritycontainerdonScreen._base.Show(self)

    self.isopen = true
    if self.bgimage.texture then
        self.bgimage:Show()
    else
        self.bganim:GetAnimState():PlayAnimation("open")
    end
    if self.edit_text then
        self.edit_text.inst.TextWidget:ShowEditCursor(false)
    end
end

function SecuritycontainerdonScreen:Close()
    if self.isopen then
        self.edit_text:SetEditing(false)
        EndWritingPassword(self.writeable)
        
        self.writeable = nil
        
		if self.bgimage.texture then
            self.bgimage:Hide()
        else
            self.bganim:GetAnimState():PlayAnimation("close")
        end
		
        
        if self.menu then
            self.menu:Clear()
        end
		if self.menuB then
            self.menuB:Clear()
        end	
		if self.menuC then
            self.menuC:Clear()
        end	
        self.root:KillAllChildren()
        self.root:Kill()
        self.scalingroot:Kill()
        
        self.isopen = false
        
        self.inst:DoTaskInTime(.3, function() TheFrontEnd:PopScreen(self) end)
    end
end
-------------------------------------------------------------------------------

function SecuritycontainerdonScreen:OverrideText(text)
    if self.edit_text then
        self.edit_text:SetString(text)
		self.edit_text:SetFocus()
    end
end

function SecuritycontainerdonScreen:GetText()
    return self.edit_text and self.edit_text:GetString() or ""
end
-------------------------------------------------------------------------------
local function PushScreen(screen)
    if screen == nil then return end
    TheFrontEnd:PushScreen(screen)
end

function SecuritycontainerdonScreen:PushScreen()
    local screenstack = TheFrontEnd.screenstack
    local stackdepth = #screenstack
    for i = stackdepth, 1, -1 do
        if screenstack[i] == self then
            return false
        end
    end
    PushScreen(self)
    return true
end

local function PopScreen(screen)
    if screen == nil then return end
    local self = TheFrontEnd
    self.focus_locked = false
    self:SetForceProcessTextInput(false)
    TheInputProxy:FlushInput()
    screen:OnBecomeInactive()
    table.remove(self.screenstack, #self.screenstack)
    self.screenroot:RemoveChild(screen)
    if #self.screenstack > 0 and screen ~= self.screenstack[#self.screenstack] then
        self.screenstack[#self.screenstack]:SetFocus()
        self.screenstack[#self.screenstack]:OnBecomeActive()
        self:Update(0)
    end
end

function SecuritycontainerdonScreen:PopScreen()
    local screenstack = TheFrontEnd.screenstack
    local stackdepth = #screenstack
    if stackdepth > 0 and screenstack[stackdepth] == self then
        PopScreen(self)
        return true
    end
    return false
end

function SecuritycontainerdonScreen:OnControl(control, down)
    if SecuritycontainerdonScreen._base.OnControl(self, control, down) then
        return true
    end
    
	if down then
        return false
        
    elseif control == CONTROL_INSPECT_SELF or control == CONTROL_TOGGLE_DEBUGRENDER  or control == CONTROL_PAUSE or control == CONTROL_TOGGLE_SAY or control == CONTROL_TOGGLE_WHISPER or control == CONTROL_TOGGLE_SLASH_COMMAND then
        return false  
    end

    return false
	
end

local function MakeSecurityWidget(inst, doer, methodmenu)
    if inst and inst:HasTag("accept_donlocksystem") then
        if doer and doer.HUD then
			local screen = SecuritycontainerdonScreen(doer, inst, methodmenu)
			if screen == nil then
				return false
			end
			doer.HUD:OpenScreenUnderPause(screen)
			return true
	   end
        return false
    else
        return false
    end
end

return MakeSecurityWidget
